form = nil;
formName = "demo02";

function gtkDidLoad()
	GTK.Core.GUI:addImage({ name="panel-bg", path="assets/textures/gui/gui_items.tga", origin={548, 2304}, size={582, 118}, margin={10, 10, 10, 10} });
	GTK.Core.GUI:addImage({ name="test-image", path="mod_assets/grimtk/textures/test.tga", size={128, 128} });

	itemTemplate = {
		type = "GImageView",
		size = {64, 64},
		minSize = {32, 32},
		maxSize = {128, 128},
		bgImage = "test-image",
	};	
	
	form = {
		name = formName,
		type = "GWindow",
		gravity = GTK.Constants.Gravity.North,
		offset = {0, 0},
		size = {626, 148},
		bgColor = {0, 0, 0, 0},
		bgImage = "panel-bg",
		bgDrawMode = GTK.Constants.ImageDrawMode.Stretched,
		draggable = true,
		children = {
			{
				name = "itemContainer",
				type = "GWidget",
				position = {10, 10},
				size = {480, 128},
				borderColor = {255, 0, 0, 128},
				borders = {1, 1, 1, 1},
				layout = {
					type = "GBoxLayout",
					direction = GTK.Constants.Direction.Horizontal,
					gravity = GTK.Constants.Gravity.NorthWest,			
					hideOverflow = true,
					spacing = {4, 4},
					margin = {4, 4, 4, 4}
				},
				children = { }
			},
			{
				type = "GButton",
				position = {500, 10},
				size = {110, 24},
				padding = {4, 4, 4, 4},
				text = "Add Item",
				bgColor = {0, 0, 0, 255},
				onPressed = function(sender, mouseState)
					local container = sender:rootWidget():findChild("itemContainer");
					
					if ( container ) then
						local widget = GTK.Widgets.GWidget.createGeneric(itemTemplate);
						
						if ( widget ) then
							container:addChild(widget);
						end
					end
				end
			},
			{
				type = "GButton",
				position = {500, 40},
				size = {110, 24},
				padding = {4, 4, 4, 4},
				text = "Remove Item",
				bgColor = {0, 0, 0, 255},
				onPressed = function(sender, mouseState)
					local container = sender:rootWidget():findChild("itemContainer");
					
					if ( container ) then
						container:removeChildAtIndex(container:childCount());
					end
				end
			},
			{
				type = "GButton",
				position = {500, 70},
				size = {110, 24},
				padding = {4, 4, 4, 4},
				text = "Fade In / Out",
				bgColor = {0, 0, 0, 255},
				onPressed = function(sender, mouseState)
					local root = sender:rootWidget();
					
					if ( root ) then
						root:stopAllActions();
						
						if ( root.data.opacity == 1.0 ) then
							root:runAction(GTK.Widgets.GFadeToAction.create(0.2, 1.0));
						else 
							root:runAction(GTK.Widgets.GFadeToAction.create(1.0, 1.0));
						end							
					end
				end
			},
			{
				type = "GButton",
				position = {500, 100},
				size = {110, 24},
				padding = {4, 4, 4, 4},
				text = "Move Me",
				bgColor = {0, 0, 0, 255},
				onPressed = function(sender, mouseState)
					local root = sender:rootWidget();
					
					if ( root ) then
						root:stopAllActions();
						
						if ( root.data.opacity == 1.0 ) then
							root:runAction(GTK.Widgets.GMoveToAction.create({10, 10}, 1.0));
						end							
					end
				end
			},
		}
	}

end

function showGui()
	if ( GTK.Core.GUI:getWindow(formName) == nil ) then 	
		GTK.Core.GUI:createWindow(form);
	else 
		GTK.Core.GUI:showWindow(formName);
	end
end

function hideGui()
	GTK.Core.GUI:hideWindow(formName);
end
