local kNotebookScriptEntity = "GTKNotebook";
local kNotebookScriptPath = "mod_assets/gtk_notebook/scripts/notebook.lua";


defineObject{
	name = "base_notebook",
	baseObject = "base_item",
	placement = "floor",
	tags = { "item" },
	editorIcon = 24,
	reflectionMode = "never",
	components = {
		{
			class = "Null",
			onInit = function(self, champion) 
				if ( findEntity(kNotebookScriptEntity) == nil ) then
					local notebook = spawn("script_entity", 1, 1, 1, 1, 1, kNotebookScriptEntity).script:loadFile(kNotebookScriptPath);
				end
			end
		}
	}
}

defineObject{
	name = "gtk_notebook",
	baseObject = "base_notebook",
	components = {
		{
			class = "Model",
			model = "assets/models/items/tome.fbx",
		},
		{
			class = "Item",
			uiName = "Notebook",
			description = "A simple notebook with insets for carrying notes, scrolls and custom entries.",
			gfxIndex = 30,
			weight = 0.2,
			traits = { "tome" },
			onUnequipItem = function(self, champion, slot)
				GTKNotebook.script:close();
			end
		},
		{
			class = "ContainerItem",
			containerType = "",
			openSound = "container_sack_open",
			closeSound = "container_sack_close",
			onInit = function(self)
				self:insertItem(10, spawn("rock").item);
			end,
			onInsertItem = function(self, item)
			
			end,
			onRemoveItem = function(self, item)
				
			end,
		},
		{
			class = "UsableItem",
			onUseItem = function(self, champion)
				if ( GTKNotebook.script:isOpen() ) then
					GTKNotebook.script:close();
				else 
					GTKNotebook.script:open(champion:getOrdinal(), self.go.id);
				end
				
				-- Never destroy this item!
				return false;
			end,
		},
	},
}